// Dataset Related
const headers = {
  "age": 1,
  "sex": 2,
  "city": 3,
  "province": 4,
  "country": 5,
  "lat": 7,
  "lng": 8,
  "dateSymp": 10,
  "dateConfirmed": 12,
  "travHist": 15,
  "travLoca": 16
}
var indivDataset;
var indivWhDataset;
var areaDataset;

const startyear = 2019;
const endyear = 2020;
const startdate = [-1, -1, -1];
const enddate = [-1, -1, -1];
const mdays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

const yyidx = (yy) => yy - startyear;
const mmidx = (mm) => mm - 1;
const ddidx = (dd) => dd - 1;

var renderDate = [-1, -1, -1];
var indivMatrix = [];
var indivWhMatrix = [];
var totalMatrix = [];
var areaMatrix = [];

var totalMesh;
var maleMash;
var femaleMash;

var totalEnable = true;
var maleEnable = true;
var femaleEnable = true;

var totalIncEnable = true;
var maleIncEnable = true;
var femaleIncEnable = true;

var Gotham;
var cameraTranslation;

function preload() {
  Gotham = loadFont('data/Gotham-Bold.otf');
  indivDataset = loadTable('data/covid19_outside_wuhan_mar22.csv', 'csv', 'header');
  indivWhDataset = loadTable('data/covid19_wuhan.csv', 'csv', 'header');
}

function setup() {
  createCanvas(windowWidth, windowHeight, WEBGL); // processing we use size(x,y, P3D)
  cam = createCamera();
  cam.perspective(PI / 3.0, width / height, 0.1, 8000);
  cameraTranslation =  createVector(0, 0, 0);
  ambientLight(80);
  initDataMatrix();
  loadIndivDataset();
  loadIndivWhDataset();
  updateTotalCases();
  updateRenderDate();
  initControlPanel();
  initLabelPanel();

}


function draw() {
  orbitControl(0.5, 0.5, 0.5);
  background('#222222');
  angleMode(DEGREES);
  moveCamera();
  rotateX(40);

  updateDate();
  updateMesh();

  drawCoordFrame();
  drawDailyIncrement();
  drawTotalStats();
}

function moveCamera() {
  // Get the code from http://keycode.info/
  if (keyIsDown(87)) { //w
    cameraTranslation.z -= cameraSpeed;
  } else if (keyIsDown(83)) { //s
    cameraTranslation.z += cameraSpeed;
  } else if (keyIsDown(65)) { //a
    cameraTranslation.x -= cameraSpeed;
  } else if (keyIsDown(68)) { //d
    cameraTranslation.x += cameraSpeed;
  } else if (keyIsDown(CONTROL)) {
    cameraTranslation.y += cameraSpeed;
  } else if (keyIsDown(32)) {
    cameraTranslation.y -= cameraSpeed;
  }
  cam.move(cameraTranslation.x, cameraTranslation.y, cameraTranslation.z);
  cameraTranslation = createVector(0, 0, 0);
}

function tiltCamera() {
  angleMode(DEGREES);
  if (keyIsDown(38)) { //up
    cam.tilt(-cameraOmega);
  } else if (keyIsDown(40)) {//down
    cam.tilt(cameraOmega);
  }
}





















