const scale = 5;

var labelDateValue;
var renderDateSlider;

function initControlPanel() {
  const btnWidth = 130;
  const btnHeight = 22;
  btnTotalTrend = createButton('Total Trend');
  btnTotalTrend.mousePressed(toggleTotalTrend);
  btnTotalTrend.size(btnWidth, btnHeight);
  btnTotalTrend.position(20, 40);
  btnTotalTrend.addClass('totalcases');

  btnMaleTrend = createButton('Male Trend');
  btnMaleTrend.mousePressed(toggleMaleTrend);
  btnMaleTrend.size(btnWidth, btnHeight);
  btnMaleTrend.position(160, 40);
  btnMaleTrend.addClass('malecases');

  btnFemaleTrend = createButton('Female Trend');
  btnFemaleTrend.mousePressed(toggleFemaleTrend);
  btnFemaleTrend.size(btnWidth, btnHeight);
  btnFemaleTrend.position(300, 40);
  btnFemaleTrend.addClass('femalecases');

  btnTotalIncre = createButton('Total Increment');
  btnTotalIncre.mousePressed(toggleTotalInc);
  btnTotalIncre.size(btnWidth, btnHeight);
  btnTotalIncre.position(20, 70);
  btnTotalIncre.addClass('totalcases');

  btnMaleIncre = createButton('Male Increment');
  btnMaleIncre.mousePressed(toggleMaleInc);
  btnMaleIncre.size(btnWidth, btnHeight);
  btnMaleIncre.position(160, 70);
  btnMaleIncre.addClass('malecases');

  btnFemaleIncre = createButton('Female Increment');
  btnFemaleIncre.mousePressed(toggleFemaleInc);
  btnFemaleIncre.size(btnWidth, btnHeight);
  btnFemaleIncre.position(300, 70);
  btnFemaleIncre.addClass('femalecases');

  // let initStartYear = startYear;
  // let initEndYear = startYear + 2;
  let sliderBlockInitY = 100;
  let sliderBlockInitX = 20;
  let sliderBlockDx = 40;
  let sliderBlockDy = 20;
  labelDate = createP("Date: ");
  labelDate.position(sliderBlockInitX, sliderBlockInitY + sliderBlockDy);
  labelDateValue = createP("" + renderDate);
  labelDateValue.position(sliderBlockInitX + sliderBlockDx, sliderBlockInitY + sliderBlockDy);
  print(getTotalDays())
  renderDateSlider = createSlider(0, getTotalDays(), 0, 1);
  renderDateSlider.position(sliderBlockInitX, sliderBlockInitY);
  renderDateSlider.style('width', '400px');

  // endYearLabel = createP("End Year: ");
  // endYearLabel.position(sliderBlockInitX, sliderBlockInitY + sliderBlockDy * 2);
  // endYearValue = createP("" + initEndYear);
  // endYearValue.position(sliderBlockInitX + sliderBlockDx, sliderBlockInitY + sliderBlockDy * 2);
  // endYearSlider = createSlider(startYear, endYear, initEndYear, 1);
  // endYearSlider.position(sliderBlockInitX, sliderBlockInitY + sliderBlockDy * 3);
  // endYearSlider.style('width', '120px');

  // // Draw checkbox
  // let initCheckboxX = 20;
  // let initCheckboxY = windowHeight - 50;
  // let checkboxDy = -25;
  // let checkbox;
  // for (var i = langIdxList.len - 1; i >= 0; i--) {
  //   checkbox = createCheckbox(" " + langList[i], langSwitch[i]);
  //   checkbox.position(initCheckboxX, initCheckboxY + checkboxDy * (langIdxList.len - 1 - i));
  //   checkbox.style('color', colorList[i]);
  //   checkbox.changed(checkboxChanged);
  //   langCheckboxes.unshift(checkbox);
  // }
}

function initLabelPanel() {
  // Draw checkbox
  let initX = 20;
  let initY = windowHeight - 50;
  let dy = -30;
  let label;
  let img;
  const maxIndex = 5;
  const imgList = ['imgs/total_inc.svg', 'imgs/total_trend.svg','imgs/male_inc.svg', 'imgs/male_trend.svg', 'imgs/female_inc.svg', 'imgs/female_trend.svg'];
  const noteList = [
    'Indicates the daily increment of documented total cases.', 'Indicates the accumulated number of total cases.',
    'Indicates the daily increment of documented male cases.', 'Indicates the accumulated number of male cases.',
    'Indicates the daily increment of documented female cases.', 'Indicates the accumulated number of female cases.'];
  const noteColorList = ['#ff9035', '#ff9035', '#2692ff', '#2692ff', '#ff4f8f', '#ff4f8f'];
  const pbiasX = 30;
  const pbiasY = -10;
  for(var i = maxIndex; i >= 0; i--) {
      img = createImg(imgList[i], 'icon');
      label = createP(noteList[i]);
      img.position(initX, initY + dy * (maxIndex - i));
      img.addClass('icon')
      label.position(initX + pbiasX, initY + dy * (maxIndex - i) + pbiasY);
      label.style('color', '#DCDADA');
      label.addClass('icon-label');
  }
}

// Terrain Mesh
const div = 3;
const meshScale = div * scale;
function createMesh() {
  const meshes = [];
  var xidx, yidx;
  for (var latStep = -90 / div; latStep <= 90 / div; latStep++) {
    meshes.push([]);
    yidx = latStep + 90 / div;
    for (var lngStep = -180 / div; lngStep <= 180 / div; lngStep++) {
      meshes[yidx].push(0); 
    }
  }
  return meshes;
}

function convSum(meshes, x, y, totalNum, dt = 2, stdev = 0.7) {
  var xidx, yidx;
  for (var dx = -dt; dx <= dt; dx++) {
    for (var dy = -dt; dy <= dt; dy++) {
      xidx = x + dx;
      yidx = y + dy;
      if (meshes[yidx] != undefined && meshes[yidx][xidx] != undefined && meshes[yidx][xidx] >= 0) {
        meshes[yidx][xidx] += totalNum * Math.exp(-0.5 * Math.pow(Math.sqrt(dx * dx + dy * dy)/stdev, 2));
      }
    }
  }
}

function getMeshIndex(lat, lng) {
  var x = Math.floor(lng / div) + Math.floor(180 / div);
  var y = Math.floor(lat / div) + Math.floor(90 / div);
  return [x, y];
}

function drawDailyIncrement() {
  var [yy, mm, dd] = renderDate;
  dailyCases = indivMatrix[yyidx(yy)][mmidx(mm)][ddidx(dd)];
  var h = 0;
  var dh = 2;
  const biasH = 0;
  var lat, lng;
  var dim = 4;
  var xidx, yidx;
  var details = 12;
  const rscale = 0;
  var width;
  const widthFrom = 3;
  const widthTo = 5;
  
  var axisR, axisF, axisH;
  for (var key in dailyCases.areas) {
    areaCases = dailyCases.areas[key];
    lat = areaCases.lat;
    lng = areaCases.lng;
    [xidx, yidx] = getMeshIndex(lat, lng);
    axisR = lng * scale;
    axisF = -lat * scale;

    if (totalIncEnable) {
      h = Math.log2(totalMesh[yidx][xidx] * 10 + 1) * 10;
      width = map(areaCases.nonsexCases.length, 0, 50, widthFrom, widthTo);
      stroke('#FD9519')
      strokeWeight(width);
      line(axisR, axisF, h, axisR, axisF, h + biasH + Math.pow(dh * areaCases.nonsexCases.length, 0.75));
    }
    
    if (maleIncEnable) {
      h = Math.log2(maleMash[yidx][xidx] * 10 + 1) * 10;
      width = map(areaCases.maleCases.length, 0, 50, widthFrom * 1.5, widthTo * 1.5);
      stroke('#3399ff')
      strokeWeight(width);
      line(axisR, axisF, h, axisR, axisF, h + biasH + Math.pow(dh * areaCases.maleCases.length * 2, 0.95));
    }
    
    if (femaleIncEnable) {
      h = Math.log2(femaleMash[yidx][xidx] * 10 + 1) * 10;
      width = map(areaCases.femaleCases.length, 0, 50, widthFrom * 1.5, widthTo * 1.5);
      stroke('#ff6699')
      strokeWeight(width);
      line(axisR, axisF, h, axisR, axisF, h + biasH + Math.pow(dh * areaCases.femaleCases.length * 2, 0.95));
    }
  }
}

function drawTotalStats() {
  var xidx, yidx;
  
  var from;
  var to;
  const fromSize = 1.0;
  const toSize = 6.0;
  for(var latStep = -90 / div; latStep <= 90 / div; latStep++) {
    yidx = latStep + 90 / div;
    for(var lngStep = -180 / div; lngStep <= 180 / div; lngStep++) {
      xidx = lngStep + 180 / div;

      // total numbers
      if (totalEnable) {
        from = color('#3B3122');
        to = color('#FF8520');
        val = Math.log2(totalMesh[yidx][xidx] * 10 + 1) * 10;
        ratio = val / 50.0;
        if (ratio > 1) ratio = 1;
        stroke(lerpColor(from, to, ratio));
        strokeWeight(map(ratio, 0, 1, fromSize, toSize));
        if (val != 0)
          point(lngStep * meshScale, -latStep * meshScale, val);
      }

      // male numbers
      if (maleEnable) {
        from = color('#465253');
        to = color('#69A3ED');
        val = Math.log2(maleMash[yidx][xidx] * 10 + 1) * 10;
        ratio = val / 50.0;
        if (ratio > 1) ratio = 1;
        stroke(lerpColor(from, to, ratio));
        strokeWeight(map(ratio, 0, 1, fromSize, toSize));
        if (val != 0) 
          point(lngStep * meshScale, -latStep * meshScale, val);
      }
      
      // female numbers
      if (femaleEnable) {
        from = color('#382C34');
        to = color('#E776C3');
        val = Math.log2(femaleMash[yidx][xidx] * 10 + 1) * 10;
        ratio = val / 50.0;
        if (ratio > 1) ratio = 1;
        stroke(lerpColor(from, to, ratio));
        strokeWeight(map(ratio, 0, 1, fromSize, toSize));
        if (val != 0) 
          point(lngStep * meshScale, -latStep * meshScale, val);
        }
      }
  }
  
}

const measureLenth = 10;
const offset = 5;
function drawCoordFrame() {
  stroke('#303030');
  noFill();
  strokeWeight(1);
  rect(-180 * scale, -90 * scale, 360 * scale, 180 * scale);
  textFont(Gotham);
  fill('#4a4a4a')
  textAlign(CENTER);
  textSize(8);
  for (var lng = -180; lng <= 180; lng += 10) {
    line(lng * scale, 90 * scale + offset, 0, lng * scale, 90 * scale + measureLenth + offset, 0);
    text('' + lng, lng * scale, 90 * scale + measureLenth + offset * 3);
  }

  line(-180 * scale, 90 * scale, 0, 180 * scale, 90 * scale, 0);
  fill('#4a4a4a')
  textAlign(CENTER);
  textSize(8);
  for (var lat = -90; lat <= 90; lat += 10) {
    line(-180 * scale - offset, - lat * scale, 0, -180 * scale - measureLenth - offset, -lat * scale, 0);
    text('' + lat, - 180 * scale - measureLenth - offset * 3, - lat * scale);
  }
}